import java.io.InputStream;
import java.io.FileInputStream;
import java.io.File;

import org.w3c.dom.Document;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class ExternalRef{	
	private String basePath;
	public ExternalRef(){		
	}	

	public String getRef(String file, String lang, String targettype, String id){
		getPath();
		try{
			String tfile = file+"_"+lang+".xml";
			String path = basePath + "/xml-source/" + lang + "/" + tfile;

			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      DocumentBuilder domBuilder = factory.newDocumentBuilder();
      InputStream is = new FileInputStream(path);
      Document doc = domBuilder.parse(is);

		NodeList list = doc.getElementsByTagName(targettype);
		int i=0;
		for(i=0; i<list.getLength(); i++){
			Node node = list.item(i);
			String id_temp = node.getAttributes().getNamedItem("id").getNodeValue();			
			if(id_temp.equals(id)) break;
		}
		return (++i)+"";
        
		}catch(Exception e){
			System.err.println(e.getMessage());
			//e.printStackTrace();
			return "";
		}
	}	
	
	private void getPath(){
		basePath = System.getProperty("user.dir");
		
		//find where is the manuals directory
		File tempfile = new File(basePath);
		String parentPath = tempfile.getParent();		
		
		boolean find = false;
		while(!find){
			File tempfile2 = new File(parentPath+"/manuals");
			if(tempfile2.exists() && tempfile2.isDirectory()){
				basePath = parentPath+"/manuals";
				find = true;
		  }
		  else if(parentPath.endsWith("manuals")){
  			//if the shared directory is inside the manual directory
				basePath = parentPath;
				find = true;
		  }
		  if(!find){
		    tempfile = new File(parentPath);
		    parentPath = tempfile.getParent();
		  }
	  }
	}
}
